<?php
namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmAtualizacaoEstrutura as OmAtualizacaoEstruturaEntity;
use Teknisa\Model\Teknisa\Entities\OmAtualizacaoEstruturaOrg as OmAtualizacaoEstruturaOrgEntity;
use OrganizationsManagement\Factory;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class AtualizacaoEstrutura {

    public function save(OmAtualizacaoEstruturaEntity $atualizacaoEstrutura = null,
                         $codOperador, $nrorg, $script, $dsAtuEstrutura, $ticketId, $idResultScript, $scriptSuc, $scriptErr)
    {
        $dateNow = new \DateTime();
        if ($atualizacaoEstrutura === null){
            $atualizacaoEstrutura = new OmAtualizacaoEstruturaEntity();
            $novoCodigo = NovoCodigo::geraCodigo($nrorg, "OM_ATUALIZACAO_ESTRUTURA", 1, 10, false, false);
            $atualizacaoEstrutura->setId($novoCodigo);
            $atualizacaoEstrutura->setCdoperinclusao($codOperador);
            $atualizacaoEstrutura->setDtinclusao($dateNow);
            $atualizacaoEstrutura->setNrorg($nrorg);
            $atualizacaoEstrutura->setNrorginclusao($nrorg);
        }

        $atualizacaoEstrutura->setCdoperultatu($codOperador);
        $atualizacaoEstrutura->setDtultatu($dateNow);
        $atualizacaoEstrutura->setNrorgultatu($nrorg);

        $atualizacaoEstrutura->setScript($script);
        $atualizacaoEstrutura->setScriptSuc($scriptSuc);
        $atualizacaoEstrutura->setScriptErr($scriptErr);
        $atualizacaoEstrutura->setDsatuestrutura($dsAtuEstrutura);
        $atualizacaoEstrutura->setDsdirlog('Empty');
        $atualizacaoEstrutura->setTicketId($ticketId);
        $atualizacaoEstrutura->setIdresultscript($idResultScript);

        if(!empty($ticketId)){
            $atualizacaoEstrutura->setCdSystemTicket(OmAtualizacaoEstruturaEntity::CD_SIS_TICKET_MOVIDESK);
        }

        return $atualizacaoEstrutura;
    }


    public function saveOrg(OmAtualizacaoEstruturaOrgEntity $atualizacaoEstruturaOrg = null,
                            $codOperador, $nrorg, $nrorgId, $nrAtuEstrutId, $dsDirLog, $idResultScript)
    {
        $dateNow = new \DateTime();
        if ($atualizacaoEstruturaOrg === null){
            $atualizacaoEstruturaOrg = new OmAtualizacaoEstruturaOrgEntity();
            $novoCodigo = NovoCodigo::geraCodigo($nrorg, "OM_ATUALIZACAO_ESTRUTURA_ORG", 1, 10, false, false);
            $atualizacaoEstruturaOrg->setId($novoCodigo);
            $atualizacaoEstruturaOrg->setCdoperinclusao($codOperador);
            $atualizacaoEstruturaOrg->setDtinclusao($dateNow);
            $atualizacaoEstruturaOrg->setNrorg($nrorg);
            $atualizacaoEstruturaOrg->setNrorginclusao($nrorg);
        }

        $atualizacaoEstruturaOrg->setCdoperultatu($codOperador);
        $atualizacaoEstruturaOrg->setDtultatu($dateNow);
        $atualizacaoEstruturaOrg->setNrorgultatu($nrorg);
        $atualizacaoEstruturaOrg->setDsdirlog($dsDirLog);
        $atualizacaoEstruturaOrg->setNrorgId($nrorgId);
        $atualizacaoEstruturaOrg->setNratuestrutid($nrAtuEstrutId);
        $atualizacaoEstruturaOrg->setIdresultscript($idResultScript);

        return $atualizacaoEstruturaOrg;
    }
}
